SystemOrganization addCategory: #ImageFootprint!

!MethodReference methodsFor: '*ImageFootprint' stamp: 'hjo 3/27/2009 10:54'!
isReal

	"Is this really a method that can be called? Unlike #DoIt."
	^self actualClass canUnderstand: self methodSymbol! !

Object subclass: #ImageFootprint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFootprint'!

!ImageFootprint classSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/13/2010 09:44'!
initialize

	self new go! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 11/13/2010 10:15'!
dumpClasses

	self dumpClassesOn: (FileStream newFileNamed: self filepathForDumpClasses)! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 6/16/2011 21:19'!
dumpClassesOn: aStream

	| sortedClasses c |
	sortedClasses := Smalltalk allClasses sort: [:c1 :c2| c1 name <= c2 name].
	'Printing classes'
		displayProgressAt: Sensor cursorPoint
		from: 0 to: sortedClasses size
		during: [:bar | 1 to: sortedClasses size do: [:k| c := sortedClasses at:k.
				aStream nextPutAll: (c definition copyWithoutAll: String crlf) ; cr.
				bar value: k
				 ]
			]
! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 11/13/2010 10:22'!
dumpMethods

	self dumpMethodsOn: (FileStream newFileNamed: self filepathForDumpMethods)! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 3/25/2012 01:31'!
dumpMethodsOn: aStream

	| methodReferences lines sortedStrings |
	methodReferences := (Array streamContents: [:stream|
		Smalltalk allClasses do: [:class|
				stream nextPutAll:  class localMethods.
				stream nextPutAll:  class class localMethods.
			]
		]) collect: [:cm | MethodReference class: cm methodClass selector: cm selector ].
	methodReferences := methodReferences reject: [:each| (each classSymbol = #ClassTrait) and: [each methodSymbol = #for:]
 ].
	lines := methodReferences collect: [:m| |vs cm| 
		vs := m stringVersion.
		vs isNil ifTrue: [ vs := m stringVersionDefault ].
		cm := m compiledMethod.
		vs, '    ----', cm timeStamp].
	sortedStrings := lines asSortedCollection.    

	'Printing methods'
		displayProgressAt: Sensor cursorPoint 
		from: 0 to: sortedStrings size
 		during: [:bar| 
			1 to: sortedStrings size do: [:k| 
				aStream nextPutAll: (sortedStrings at: k)  ; cr. 
				bar value: k]]

! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 3/27/2009 10:58'!
fileStem

	^FileDirectory baseNameFor: (FileDirectory localNameFor: SmalltalkImage current imageName)! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2009 00:01'!
filepathForDumpClasses

	^self fileStem , '.classDump'! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2009 00:02'!
filepathForDumpMethods

	^self fileStem , '.methodDump'! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 11/13/2010 10:24'!
filepathForImageFootprint

	^self fileStem , '.imageFootprint'! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2009 00:07'!
fullFilepathForDumpClasses

	^FileDirectory fullPathForURI: self filepathForDumpClasses! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2009 00:07'!
fullFilepathForDumpMethods

	^FileDirectory fullPathForURI: self filepathForDumpMethods! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 11/13/2010 10:24'!
fullFilepathForImageFootprint

	^FileDirectory fullPathForURI: self filepathForImageFootprint! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2009 00:08'!
fullFilepaths

	^Array with: self fullFilepathForDumpClasses with: self fullFilepathForDumpMethods! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 6/16/2011 21:47'!
go

	|stream|
	stream := FileStream newFileNamed: self filepathForImageFootprint.
	self dumpClassesOn: stream.
	self dumpMethodsOn: stream.
	stream close.
	SoundService default soundEnabled: true.
	SoundService default new beep
! !
ImageFootprint initialize!
